
int new_node(int id,double x,double y,double z,double v,double qinv,int interface )
// int id, interface;
// double x, y, z, v, qinv;
{

	if( (n_nodes+1) > MAX_NODES ) return(-1);
	
	node[n_nodes].id=id;
	node[n_nodes].ifc=interface;
	node[n_nodes].x[0]=x;
	node[n_nodes].x[1]=y;
	node[n_nodes].x[2]=z;
	node[n_nodes].v=v;
	node[n_nodes].v_orig=v;
	node[n_nodes].ratio=1.0/qinv;
	node[n_nodes].ratio_orig=1.0/qinv;
	node[n_nodes].qinv=qinv;
	node[n_nodes].qinv_orig=qinv;
	node[n_nodes].hits=0;
	node[n_nodes].touched=0;
	node[n_nodes].nt=0;
	if( n_nodes==0 ) {
		model_z_min=z;
		model_z_max=z;
		}
	else if( z<model_z_min ) {
		model_z_min=z;
		}
	else if( z>model_z_max ) {
		model_z_max=z;
		}

	n_nodes++;
	return(n_nodes-1);
	}


int node_in_model_par(int n,int mp)
// int n, mp;
{
	int i, nn;
	struct model_par_rec *m;

	m = &model_par[mp];
	nn = m->n;
	for( i=0; i<nn; i++ ) {
		if( m->node[i] == n ) return(TRUE);
		}
	return(FALSE);
	}

int perturb_refl_nodes(struct model_par_rec *m,double ds)
// struct model_par_rec *m;
// double ds;
{
	int i, j, nn;
	struct node_rec *mynode;

	nn = m->n;
	for( i=0; i<n_tetras; i++ ) tetra[i].marked=0;
	for( i=0; i<nn; i++ ) {
		mynode= &node[m->node[i]];
		for( j=0; j<3; j++ ) mynode->x[j]+=ds*m->weight[i]*m->t[3*i+j];
		for( j=0; j<mynode->nt; j++ ) mynode->t[j]->marked=1;
		}
	for( i=0; i<n_tetras; i++ ) if( tetra[i].marked ) velocity_eqn( &tetra[i] );
	return(1);
	}




int findnode(int id)
{
	int i;
	struct nodeid_element_rec t, *my_elem;

	if( !nodeidlist_exists ) {
		nodeidlist_exists=TRUE;
		nodeidlist=(struct nodeid_element_rec*)
			malloc(n_nodes*sizeof(struct nodeid_element_rec));
		if( nodeidlist==NULL ) {
			fprintf(stderr,"Error: Out of Memory (findnode)\n");
			exit(-1);
			}
		for( i=0; i<n_nodes; i++ ) {
			nodeidlist[i].id=node[i].id;
			nodeidlist[i].index=i;
			}
		qsort( nodeidlist, n_nodes, sizeof(struct nodeid_element_rec), compare_nodeid );
		}

	t.id=id;
	t.index=(-1);
	
	my_elem=(struct nodeid_element_rec*)bsearch(&t, nodeidlist, n_nodes,
		sizeof(struct nodeid_element_rec), compare_nodeid);
	if( my_elem == NULL ) {
		return(-1);
		}
	else {
		return(my_elem->index);
		}	
	}
	
	